function [xhat, Hhat, fhat,params,retcodehat] = findmode(Hinit,num,nparam,nvar,nexog,nforerrors)

param = zeros(nparam,1);
xhat = zeros(nparam,num);
params = zeros(nparam,num);
Hhat = zeros(nparam,nparam,num);
fhat = zeros(num,1);
retcodehat = zeros(num,1);
  
for q = 1:num
    param(1,1) = gamrnd(12.25,0.142857);    %gamm (1.75, 0.5)
    param(2,1) = gamrnd(16.00,0.125);       %kappa (2,.5)
    param(3:4,1) = betarnd(2.6250,2.6250,2,1);    %omegap
    param(5,1) = normrnd(1.50,0.3);         %phipi
    param(6,1) = normrnd(0.12,0.05);        %phiy
    param(7,1) = betarnd(2.6250,2.6250);    %theta
    param(8,1) = betarnd(2.6250,2.6250);    %gpsi
    param(9,1) = gamrnd(400,0.0125);       %s
    param(10:11,1) = betarnd(2.6250,2.6250,2,1);    %chip
    param(12:21,1) = betarnd(2.9750,1.2750,nexog,1);% rho's
    param(22,1) = gamrnd(4.00,0.05,1,1); %gammg
    param(23,1) = gamrnd(4,0.05); %gammz (.1, .03)
    param(24:33,1) = rand(nexog,1);        %sigma's
    param(34,1) = normrnd(.12,.05);      %phiyd
       
    Theta = logpostmodel(param',nvar,nexog,nforerrors);      
    
    while real(Theta) == inf  % initial value has to work
    param(1,1) = gamrnd(12.25,0.142857);    %gamm (1.75, 0.5)
    param(2,1) = gamrnd(16.00,0.125);       %kappa (2,.5)
    param(3:4,1) = betarnd(2.6250,2.6250,2,1);    %omegap
    param(5,1) = normrnd(1.50,0.3);         %phipi
    param(6,1) = normrnd(0.12,0.05);        %phiy
    param(7,1) = betarnd(2.6250,2.6250);    %theta
    param(8,1) = betarnd(2.6250,2.6250);    %gpsi
    param(9,1) = gamrnd(400,0.0125);       %s
    param(10:11,1) = betarnd(2.6250,2.6250,2,1);    %chip
    param(12:21,1) = betarnd(2.9750,1.2750,nexog,1);% rho's
    param(22,1) = gamrnd(4.00,0.05,1,1); %gammg
    param(23,1) = gamrnd(4,0.05); %gammz (.1, .03)
    param(24:33,1) = rand(nexog,1);        %sigma's
    param(34,1) = normrnd(.12,.05);      %phiyd
       

   Theta = logpostmodel(param',nvar,nexog,nforerrors);      %theta is log posterior.
   end
   [fhat1,xhat1,ghat1,Hhat1,itct1,fcount1,retcodehat1] = csminwel('logpostmodel',param',Hinit,[],1e-7,1000);
      
    xhat(:,q) = xhat1;
    params(:,q) = param;
    Hhat(:,:,q) = Hhat1;
    fhat(q,1) = fhat1;
    retcodehat(q,1) = retcodehat1;
    save modestest xhat params Hhat fhat retcodehat  % save modes as you go 
end