% variables.m
% Assigns variable numbers.

vnames = {  'cr'        % 1 consumption: Ricardian agents
            'cnr'       % 2 consumption: Non-Ricardian agents
            'R'         % 3 nominal interest rate
            'i'         % 4 investment
            'k'         % 5 private k
            'v'         % 6 k utilization rate
            'l'         % 7 labor
            'y'         % 8 output 
            'g'         % 9 govt consumption
            'c'         %10 aggregate consumtpion
            'q'         %11 Lagragina multiplier for a unit of investment goods				
            'rk'        %12 real return for private k 
            'w'         %13 real wage 
            'pi'        %14 inflation for consumption goods 
            'b'         %15 govt debt
            'sb'        %16 b/y
            'tauk'      %17 tauk
            'taul'      %18 taul
            'r'         %19 real interest rate check
            'kbar'      %20 effective unit of k
            'z'         %21 trasnfers 
            'mc'        %22 real marginal cost
            'Tk'        %23
            'Tl'        %24
            'rev'       %25 income tax revenue
            'f1k'       %26 dummy for capital foresight
            'f2k'       %27 dummy for capital foresight
            'f3k'       %28 dummy for capital foresight
            'f4k'       %29 dummy for capital foresight
            'f5k'       %30 dummy for capital foresight  
            'f6k'       %31 dummy for capital foresight  
            'f7k'       %32 dummy for capital foresight  
                 
            'f1l'       %33 dummy for labor foresight
            'f2l'       %34 dummy for laboar foresight
            'f3l'       %35 dummy for labor foresight
            'f4l'       %36 dummy for labor foresight  
            'f5l'       %37 dummy for labor foresight  
            'f6l'       %38 dummy for labor foresight  
            'f7l'       %39 dummy for labor foresight  
                
            'xcr'       %40 cr(t+1)
            'xpi'       %41 pi(t+1)
            'xub'       %42 ub(t+1)
            'xi'        %43 i(t+1)
            'xui'       %44 ui(t+1)
            'xq'        %45 q(t+1)
            'xrk'       %46 rk(t+1)
            'xtk'       %47 tauk(t+1)
            'xw'        %48 w(t+1)
            
            'ua'        %49 general preference shock
            'ub'        %50 investment shock in adjustment costs
            'um'        %51 technology shock
            'ui'        %52 wage markup shock
            'uw'        %53 price markup shock
            'up'        %54 monetary policy shock
            'ug'        %55 g shock
            'utk'       %56 tauk shock
            'utl'       %57 taul shock
            'uz'        %58 z shock
          };  
      
for j = 1:size(vnames,1)
   jnk(j,:) = strcat({'N'},vnames(j,:));
   eval([char(jnk(j,:)) ' = j;']);      
end


