% variables.m
% Assigns variable numbers.

vnames = {  'c    '   %1  consumption
            'k    '   %2  capital stock
            'l    '   %3  output
            'y    '   %4  labor supply
            'i    '   %5  investment  
            'r	  '   %6  interest rate 
            'nr	  '	  %7  net return to capital 
 %           'b	  '   %8  debt		 		
            'g    '	  %9  government spending	   
 %           'sb'      %10  debt output ratio
            'z'       %11 transfer 
            'sg'      %12 spending output ratio
            'tauk '   %13 capital tax rate				
            'taul'	  %14 labor tax rate
            'Tk'      %15
            'Tl'      %16
            'rev'     %17 income tax revenue
            'f1k'     %18 dummy for capital foresight
            'f2k'     %19 dummy for capital foresight
            'f3k'     %20 dummy for capital foresight
            'f4k'     %21 dummy for capital foresight
            'f5k'     %22 dummy for capital foresight  
            'f6k'     %23 dummy for capital foresight  
            'f7k'     %24 dummy for capital foresight  
                 
            'f1l'     %25 dummy for labor foresight
            'f2l'     %26 dummy for laboar foresight
            'f3l'     %27 dummy for labor foresight
            'f4l'     %28 dummy for labor foresight  
            'f5l'     %29 dummy for labor foresight  
            'f6l'     %30 dummy for labor foresight  
            'f7l'     %31 dummy for labor foresight  

            'ua'      %32 technology shock
            'ug'      %33 govt consumption shock
%            'uz'      %34 transfers shock
            'utk'     %35 capital tax rate shock
            'utl'     %36 labor tax rate shock
            };
      
for j = 1:size(vnames,1)
   jnk(j,:) = strcat({'N'},vnames(j,:));
   eval([char(jnk(j,:)) ' = j;']);      
end


